﻿namespace ComponentFramework.Modules
{
    /// <summary>
    /// Provides an alternative to pre-processor instructions to differentiate Debug code from Release code.
    /// </summary>
    /// <see cref="AutoLoadAttribute"/>
    public enum RunMode
    {
        /// <summary>
        /// None (the default value)
        /// </summary>
        None,
        /// <summary>
        /// Debug mode (if the DEBUG pre-processor flag is enabled)
        /// </summary>
        Debug,
        /// <summary>
        /// Release mode (if no DEBUG pre-processor flag is set)
        /// </summary>
        Release
    }
}