﻿using System;
using ComponentFramework;
using ComponentFramework.Modules;
using MTV3D65;
using TroubleInEuclidea.Services;
using TroubleInEuclidea.Structure;

namespace TroubleInEuclidea.Components
{
    [AutoLoad]
    class Camera : Component
    {
        TVCamera camera;
        TV_2DVECTOR currentPosition;

        public Camera(ICore core) : base(core) { }

        public override void Initialize()
        {
            Core.Engine.SetAngleSystem(CONST_TV_ANGLE.TV_ANGLE_RADIAN);

            camera = CameraFactory.GetCamera(0);
            camera.SetViewFrustum(50, 100, 0.01f);
        }

        public override void Update(TimeSpan elapsedTime)
        {
            TV_2DVECTOR destinationPosition = PlayerState.Position / 10;
            currentPosition = currentPosition.Lerp(destinationPosition, 0.05f);

            camera.SetPosition(currentPosition.x, currentPosition.y, -13.5f);
        }

        [ServiceDependency]
        public IPlayerState PlayerState { private get; set; }
    }
}
