﻿using ComponentFramework;
using ComponentFramework.Modules;
using MTV3D65;

namespace TroubleInEuclidea.Components
{
    [AutoLoad]
    class PostProcessing : Component
    {
        TVRenderSurface glowRs;
        TVGraphicEffect glowFx;

        public PostProcessing(ICore core) : base(core) {}

        public override void Initialize()
        {
            glowRs = Scene.CreateRenderSurfaceEx(-1, -1, CONST_TV_RENDERSURFACEFORMAT.TV_TEXTUREFORMAT_X8R8G8B8, false, true, 0.5f);

            glowFx = new TVGraphicEffect();
            glowFx.InitGlowEffect(glowRs);
            glowFx.SetGlowParameters(new TV_COLOR(1, 1, 1, 1), 1.3f, 0.7f);
        }

        public override void PreDraw()
        {
            glowFx.UpdateGlow(); 
        }

        public override void PostDraw()
        {
            Scene.SetTextureFilter(CONST_TV_TEXTUREFILTER.TV_FILTER_BILINEAR);

            glowRs.BltFromMainBuffer();
            glowFx.DrawGlow();
        }
    }
}
