﻿using ComponentFramework;
using TroubleInEuclidea.Components.Enemies;
using TroubleInEuclidea.Structure;
using MTV3D65;

namespace TroubleInEuclidea.Components.Waves
{
    class LinearWave<T> : Wave<T> where T : Enemy
    {
        const float Padding = 1;

        public Direction Direction { get; set; }

        public LinearWave(ICore core) : base(core) { }

        protected override void PlaceEnemies()
        {
            if (Direction == Direction.None)
                Direction = RandomHelper.EnumField<Direction>(true);

            TV_2DVECTOR tangent = Direction.GetTangent().AsVector().ComponentWiseProduct(LevelState.Size / 2 - Padding * Vector2.One);
            TV_2DVECTOR startPosition = Direction.AsVector().ComponentWiseProduct(LevelState.Size / 2 - Padding * Vector2.One);

            float halfLength = WaveEnemies.Length / 2f;
            for (int i = 0; i < WaveEnemies.Length; i++)
                WaveEnemies[i].Position = startPosition + (halfLength - i) / halfLength * tangent;
        }
    }
}