﻿using ComponentFramework;
using MTV3D65;
using TroubleInEuclidea.Components.Enemies;
using TroubleInEuclidea.Structure;

namespace TroubleInEuclidea.Components.Waves
{
    class RandomWave<T> : Wave<T> where T : Enemy
    {
        public RandomWave(ICore core) : base(core) { }

        protected override void PlaceEnemies()
        {
            foreach (var enemy in WaveEnemies)
            {
                TryPlace(enemy, () => new TV_2DVECTOR(
                                              RandomHelper.Centered(LevelState.Size.x / 2 - enemy.Size.x / 2),
                                              RandomHelper.Centered(LevelState.Size.y / 2 - enemy.Size.y / 2)));

                enemy.MovementDelay = 1;
            }
        }
    }
}