﻿using ComponentFramework;
using TroubleInEuclidea.Components.Enemies;
using TroubleInEuclidea.Components.Waves;
using TroubleInEuclidea.Structure;

namespace TroubleInEuclidea.Components.Waves
{
    class SynchronousBurstWave<T> : Wave<T> where T : Enemy
    {
        public SynchronousBurstWave(ICore core) : base(core) { }

        protected override void CreateEnemies()
        {
            int enemiesBySide = WaveEnemies.Length / 4;

            Core.LoadComponent(new BurstWave<T>(Core) { Horizontal = Direction.Left, Vertical = Direction.Up, Count = enemiesBySide });
            Core.LoadComponent(new BurstWave<T>(Core) { Horizontal = Direction.Left, Vertical = Direction.Down, Count = enemiesBySide });
            Core.LoadComponent(new BurstWave<T>(Core) { Horizontal = Direction.Right, Vertical = Direction.Up, Count = enemiesBySide });
            Core.LoadComponent(new BurstWave<T>(Core) { Horizontal = Direction.Right, Vertical = Direction.Down, Count = enemiesBySide });
        }

        protected override void PlaceEnemies()
        {
            // Already placed by the sub-components
        }
    }
}