﻿using ComponentFramework;
using ComponentFramework.Modules;
using TroubleInEuclidea.Structure;
using System;

namespace TroubleInEuclidea.Services
{
    class GameState : Service, IGameState
    {
        public GameState(ICore core) : base(core) {}

        public TimeSpan DifficultyTimer { get; set; }
        public TimeSpan EnemiesTimer { get; set; }
        public DifficultyLevel Difficulty { get; set; }
        public bool Paused { get; set; }

        public void DowngradeDifficulty()
        {
            if (Difficulty != DifficultyLevel.Noob)
                Difficulty--;
            DifficultyTimer = TimeSpan.Zero;
        }

        public void UpgradeDifficulty()
        {
            if (Difficulty != DifficultyLevel.Korean)
                Difficulty++;
            DifficultyTimer = TimeSpan.Zero;
        }
    }

    interface IGameState : IService
    {
        DifficultyLevel Difficulty { get; set; }
        TimeSpan DifficultyTimer { get; set; }
        TimeSpan EnemiesTimer { get; set; }
        bool Paused { get; set; }
        void DowngradeDifficulty();
        void UpgradeDifficulty();
    }
}
