﻿using System;
using ComponentFramework;
using ComponentFramework.Modules;
using MTV3D65;

namespace TroubleInEuclidea.Services
{
    class PlayerState : Service, IPlayerState
    {
        public PlayerState(ICore core) : base(core)
        {
            Heading = new TV_2DVECTOR(1, 0);
        }

        public TV_2DVECTOR Position { get; set; }
        public TV_2DVECTOR Velocity { get; set; }

        public int Lives { get; set; }
        public bool HasNotDied { get; set; }
        public bool Alive { get; set; }
        public bool Ready { get; set; }

        public int Score { get; set; }

        public float Theta
        {
            get { return (float)Math.Atan2(Heading.y, Heading.x); }
            set { Heading = new TV_2DVECTOR((float)Math.Cos(value), (float)Math.Sin(value)); }
        }
        public TV_2DVECTOR Heading { get; set; }
    }

    interface IPlayerState : IService
    {
        bool Alive { get; set; }
        bool HasNotDied { get; set; }
        bool Ready { get; set; }
        TV_2DVECTOR Position { get; set; }
        TV_2DVECTOR Velocity { get; set; }
        float Theta { get; set; }
        TV_2DVECTOR Heading { get; set; }
        int Lives { get; set; }
        int Score { get; set; }
    }
}