﻿using System;

namespace TroubleInEuclidea.Structure
{
    static class RandomHelper
    {
        public static Random Random { get; private set; }

        static RandomHelper()
        {
            Random = new Random();
        }

        public static bool Probability(double p)
        {
            return p >= Random.NextDouble();
        }

        public static float Centered(double distance)
        {
            return (float)((Random.NextDouble() - 0.5) * distance * 2);
        }
        public static float Centered(double distance, double around)
        {
            return (float)((Random.NextDouble() - 0.5) * distance * 2 + around);
        }

        public static float Between(double min, double max)
        {
            return (float)(Random.NextDouble() * (max - min) + min);
        }

        public static T EnumField<T>(bool excludeFirst) where T : struct
        {
            var values = Enum.GetValues(typeof(T));
            return (T)values.GetValue(Random.Next(excludeFirst ? 1 : 0, values.Length));
        }
        public static T EnumField<T>() where T : struct
        {
            return EnumField<T>(false);
        }
    }
}
